Tonyu.klass.define({
  fullName: 'user.Board',
  shortName: 'Board',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Board_main() {
        "use strict";
        var _this=this;
        
        _this.w = 20;
        
        _this.h = 20;
        
        
        
        _this.areaSaves = [];
        
        _this.saveInfo = [];
        
        _this.moveLock = true;
        
        _this.pointScore = 0;
        
        _this.collectScore = [];
        
        _this.nextTypeStack = [];
        
        _this.maxType = 5;
        
        _this.eraseAmount = 4;
        
        _this.i = 1;
        for (; _this.i<_this.maxType+1 ; _this.i++) {
          Tonyu.checkLoop();
          {
            _this.collectScore[_this.i]=0;
          }
        }
        _this.savePos = - 1;
        
        _this.turnCntTextObj = new Tonyu.classes.kernel.Actor({x: 0,y: 20,text: "saves:0",align: "left"});
        
        _this.textObjB = new Tonyu.classes.kernel.Actor({x: 0,y: 370,text: "erase:0",align: "left",layer: Tonyu.globals.$frontLayer});
        
        _this.pointScoreTextObj = new Tonyu.classes.kernel.Actor({x: 100,y: 0,text: "score",align: "left"});
        
        _this.collectScoreTextObj = new Tonyu.classes.kernel.Actor({x: 100,y: 20,text: "collectScore",align: "left"});
        
        _this.mapload();
        _this.rtCnt = 0;
        
        do {
          Tonyu.checkLoop();
          if (_this.rtCnt==0||_this.rtCnt>=10) {
            _this.nextTypeStackCnt = 0;
            
            _this.i = 0;
            for (; _this.i<_this.w*_this.h*4.6 ; _this.i++) {
              Tonyu.checkLoop();
              {
                _this.nextTypeStack[_this.i]=_this.rnd(_this.maxType)+1;
              }
            }
            
          }
          _this.rtCnt++;
          _this.fillPiece();
          _this.eraseXYs = _this.matching();
          
          
        } while (_this.eraseXYs.length!=0);
        
        _this.doSave=1;
        _this.doMatching=1;
        _this.lockTime=30;
        _this.combo = 0;
        
        _this.comboScoreSum = 0;
        
        _this.moveLock=true;
        while (1) {
          Tonyu.checkLoop();
          if (_this.lockTime>0) {
            _this.lockTime--;
            
          } else {
            if (_this.doMatching) {
              _this.combo++;
              _this.moveLock=true;
              _this.eraseXYs = _this.matching();
              
              if (_this.eraseXYs.length) {
                _this.matchCnt=_this.erase(_this.eraseXYs);
              } else {
                _this.matchCnt=0;
              }
              _this.fallPieces();
              if (_this.matchCnt!=0) {
                _this.lockTime=30;
              } else {
                _this.doMatching=0;
              }
              
            } else {
              if (_this.moveLock) {
                _this.moveLock=false;
                _this.textObjB.text="獲得: "+_this.comboScoreSum+"点";
                _this.scoreUpd();
                
              }
              _this.combo=0;
              _this.comboScoreSum=0;
              
            }
            if (_this.doSave&&_this.lockTime<=0) {
              _this.save();
              _this.doSave=0;
              
            }
            
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_Board_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.w = 20;
        
        _this.h = 20;
        
        
        
        _this.areaSaves = [];
        
        _this.saveInfo = [];
        
        _this.moveLock = true;
        
        _this.pointScore = 0;
        
        _this.collectScore = [];
        
        _this.nextTypeStack = [];
        
        _this.maxType = 5;
        
        _this.eraseAmount = 4;
        
        _this.i = 1;
        for (; _this.i<_this.maxType+1 ; _this.i++) {
          Tonyu.checkLoop();
          {
            _this.collectScore[_this.i]=0;
          }
        }
        _this.savePos = - 1;
        
        _this.turnCntTextObj = new Tonyu.classes.kernel.Actor({x: 0,y: 20,text: "saves:0",align: "left"});
        
        _this.textObjB = new Tonyu.classes.kernel.Actor({x: 0,y: 370,text: "erase:0",align: "left",layer: Tonyu.globals.$frontLayer});
        
        _this.pointScoreTextObj = new Tonyu.classes.kernel.Actor({x: 100,y: 0,text: "score",align: "left"});
        
        _this.collectScoreTextObj = new Tonyu.classes.kernel.Actor({x: 100,y: 20,text: "collectScore",align: "left"});
        
        
        _thread.enter(function _trc_Board_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$mapload(_thread);
              __pc=1;return;
            case 1:
              
              _this.rtCnt = 0;
              
            case 2:
              if (_this.rtCnt==0||_this.rtCnt>=10) {
                _this.nextTypeStackCnt = 0;
                
                _this.i = 0;
                for (; _this.i<_this.w*_this.h*4.6 ; _this.i++) {
                  Tonyu.checkLoop();
                  {
                    _this.nextTypeStack[_this.i]=_this.rnd(_this.maxType)+1;
                  }
                }
                
              }
              _this.rtCnt++;
              _this.fiber$fillPiece(_thread);
              __pc=3;return;
            case 3:
              
              _this.fiber$matching(_thread);
              __pc=4;return;
            case 4:
              _this.eraseXYs=_thread.retVal;
              
            case 5     :
              if (_this.eraseXYs.length!=0) { __pc=2; break; }
            case 6     :
              
              _this.doSave=1;
              _this.doMatching=1;
              _this.lockTime=30;
              _this.combo = 0;
              
              _this.comboScoreSum = 0;
              
              _this.moveLock=true;
            case 7:
              if (!(1)) { __pc=22    ; break; }
              if (!(_this.lockTime>0)) { __pc=8     ; break; }
              {
                _this.lockTime--;
              }
              __pc=20    ;break;
            case 8     :
              if (!(_this.doMatching)) { __pc=14    ; break; }
              _this.combo++;
              _this.moveLock=true;
              _this.fiber$matching(_thread);
              __pc=9;return;
            case 9:
              _this.eraseXYs=_thread.retVal;
              
              if (!(_this.eraseXYs.length)) { __pc=11    ; break; }
              _this.fiber$erase(_thread, _this.eraseXYs);
              __pc=10;return;
            case 10:
              _this.matchCnt=_thread.retVal;
              
              __pc=12    ;break;
            case 11    :
              _this.matchCnt=0;
            case 12    :
              
              _this.fiber$fallPieces(_thread);
              __pc=13;return;
            case 13:
              
              if (_this.matchCnt!=0) {
                _this.lockTime=30;
              } else {
                _this.doMatching=0;
              }
              __pc=17    ;break;
            case 14    :
              if (!(_this.moveLock)) { __pc=16    ; break; }
              _this.moveLock=false;
              _this.textObjB.text="獲得: "+_this.comboScoreSum+"点";
              _this.fiber$scoreUpd(_thread);
              __pc=15;return;
            case 15:
              
            case 16    :
              
              _this.combo=0;
              _this.comboScoreSum=0;
            case 17    :
              
              if (!(_this.doSave&&_this.lockTime<=0)) { __pc=19    ; break; }
              _this.fiber$save(_thread);
              __pc=18;return;
            case 18:
              
              _this.doSave=0;
            case 19    :
              
            case 20    :
              
              _this.fiber$update(_thread);
              __pc=21;return;
            case 21:
              
              __pc=7;break;
            case 22    :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      scoreUpd :function _trc_Board_scoreUpd() {
        "use strict";
        var _this=this;
        var i;
        
        _this.pointScoreTextObj.text="累計点: "+_this.pointScore;
        _this.collectScoreTextObj.text=_this.collectScore[1];
        i = 2;
        for (; i<_this.maxType+1 ; i++) {
          Tonyu.checkLoop();
          {
            _this.collectScoreTextObj.text=_this.collectScoreTextObj.text+":"+_this.collectScore[i];
          }
        }
      },
      fiber$scoreUpd :function _trc_Board_f_scoreUpd(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        
        _this.pointScoreTextObj.text="累計点: "+_this.pointScore;
        _this.collectScoreTextObj.text=_this.collectScore[1];
        i = 2;
        for (; i<_this.maxType+1 ; i++) {
          Tonyu.checkLoop();
          {
            _this.collectScoreTextObj.text=_this.collectScoreTextObj.text+":"+_this.collectScore[i];
          }
        }
        
        _thread.retVal=_this;return;
      },
      setNextPiece :function _trc_Board_setNextPiece(x,y) {
        "use strict";
        var _this=this;
        var type;
        
        type = _this.nextTypeStack[_this.nextTypeStackCnt];
        
        _this.area[x][y].type=type;
        _this.area[x][y].repositionAbs(x,y);
        _this.nextTypeStackCnt++;
        if (_this.nextTypeStackCnt>=_this.nextTypeStack.length) {
          _this.nextTypeStackCnt=0;
        }
      },
      fiber$setNextPiece :function _trc_Board_f_setNextPiece(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var type;
        
        type = _this.nextTypeStack[_this.nextTypeStackCnt];
        
        _this.area[x][y].type=type;
        _this.area[x][y].repositionAbs(x,y);
        _this.nextTypeStackCnt++;
        if (_this.nextTypeStackCnt>=_this.nextTypeStack.length) {
          _this.nextTypeStackCnt=0;
        }
        
        _thread.retVal=_this;return;
      },
      fillPiece :function _trc_Board_fillPiece() {
        "use strict";
        var _this=this;
        var y;
        var x;
        
        y = _this.h-1;
        for (; y>0 ; y--) {
          Tonyu.checkLoop();
          {
            x = 0;
            for (; x<_this.w ; x++) {
              Tonyu.checkLoop();
              {
                if (_this.area[x][y]!=0) {
                  _this.setNextPiece(x,y);
                  
                }
              }
            }
          }
        }
      },
      fiber$fillPiece :function _trc_Board_f_fillPiece(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var y;
        var x;
        
        
        _thread.enter(function _trc_Board_ent_fillPiece(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              y = _this.h-1;
              
            case 1:
              if (!(y>0)) { __pc=8     ; break; }
              x = 0;
              
            case 2:
              if (!(x<_this.w)) { __pc=6     ; break; }
              if (!(_this.area[x][y]!=0)) { __pc=4     ; break; }
              _this.fiber$setNextPiece(_thread, x, y);
              __pc=3;return;
            case 3:
              
            case 4     :
              
            case 5     :
              x++;
              __pc=2;break;
            case 6     :
              
            case 7     :
              y--;
              __pc=1;break;
            case 8     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      collect :function _trc_Board_collect(type,ammo) {
        "use strict";
        var _this=this;
        
        _this.collectScore[type]+=ammo;
        _this.scoreUpd();
      },
      fiber$collect :function _trc_Board_f_collect(_thread,type,ammo) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.collectScore[type]+=ammo;
        
        _thread.enter(function _trc_Board_ent_collect(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$scoreUpd(_thread);
              __pc=1;return;
            case 1:
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      makeTempBoard :function _trc_Board_makeTempBoard() {
        "use strict";
        var _this=this;
        var temp;
        var i;
        var j;
        
        temp = [];
        
        i = 0;
        for (; i<_this.w ; i++) {
          Tonyu.checkLoop();
          {
            temp[i]=[];
            j = 0;
            for (; j<_this.h ; j++) {
              Tonyu.checkLoop();
              {
                temp[i][j]=0;
              }
            }
          }
        }
        return temp;
      },
      fiber$makeTempBoard :function _trc_Board_f_makeTempBoard(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var temp;
        var i;
        var j;
        
        temp = [];
        
        i = 0;
        for (; i<_this.w ; i++) {
          Tonyu.checkLoop();
          {
            temp[i]=[];
            j = 0;
            for (; j<_this.h ; j++) {
              Tonyu.checkLoop();
              {
                temp[i][j]=0;
              }
            }
          }
        }
        _thread.retVal=temp;return;
        
        
        _thread.retVal=_this;return;
      },
      fallPieces :function _trc_Board_fallPieces() {
        "use strict";
        var _this=this;
        var chkArea;
        var y;
        var x;
        var fcnt;
        var temp;
        
        chkArea = _this.makeTempBoard();
        
        y = _this.h-1;
        for (; y>0 ; y--) {
          Tonyu.checkLoop();
          {
            x = 0;
            for (; x<_this.w ; x++) {
              Tonyu.checkLoop();
              {
                if (_this.area[x][y]!=0) {
                  fcnt = _this.fallPiecesRecursion(_this.area,x,y,0);
                  
                  if (fcnt>0) {
                    temp = _this.area[x][y-fcnt];
                    
                    _this.area[x][y-fcnt]=_this.area[x][y];
                    _this.area[x][y]=temp;
                    _this.area[x][y].reposition(x,y);
                    
                  } else {
                    if (fcnt<0) {
                      _this.setNextPiece(x,y);
                      
                    }
                  }
                  
                }
              }
            }
          }
        }
      },
      fiber$fallPieces :function _trc_Board_f_fallPieces(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var chkArea;
        var y;
        var x;
        var fcnt;
        var temp;
        
        
        _thread.enter(function _trc_Board_ent_fallPieces(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$makeTempBoard(_thread);
              __pc=1;return;
            case 1:
              chkArea=_thread.retVal;
              
              y = _this.h-1;
              
            case 2:
              if (!(y>0)) { __pc=13    ; break; }
              x = 0;
              
            case 3:
              if (!(x<_this.w)) { __pc=11    ; break; }
              if (!(_this.area[x][y]!=0)) { __pc=9     ; break; }
              _this.fiber$fallPiecesRecursion(_thread, _this.area, x, y, 0);
              __pc=4;return;
            case 4:
              fcnt=_thread.retVal;
              
              if (!(fcnt>0)) { __pc=5     ; break; }
              {
                temp = _this.area[x][y-fcnt];
                
                _this.area[x][y-fcnt]=_this.area[x][y];
                _this.area[x][y]=temp;
                _this.area[x][y].reposition(x,y);
              }
              __pc=8     ;break;
            case 5     :
              if (!(fcnt<0)) { __pc=7     ; break; }
              _this.fiber$setNextPiece(_thread, x, y);
              __pc=6;return;
            case 6:
              
            case 7     :
              
            case 8     :
              
            case 9     :
              
            case 10    :
              x++;
              __pc=3;break;
            case 11    :
              
            case 12    :
              y--;
              __pc=2;break;
            case 13    :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      fallPiecesRecursion :function _trc_Board_fallPiecesRecursion(area,x,y,cnt) {
        "use strict";
        var _this=this;
        
        if (area[x][y]==0) {
          return - _this.h-1;
          
        }
        if (area[x][y].type==0) {
          if (y>0) {
            cnt=_this.fallPiecesRecursion(area,x,y-1,cnt)+1;
            
          } else {
            return - _this.h;
            
          }
          
        }
        return cnt;
      },
      fiber$fallPiecesRecursion :function _trc_Board_f_fallPiecesRecursion(_thread,area,x,y,cnt) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (area[x][y]==0) {
          _thread.retVal=- _this.h-1;return;
          
          
        }
        if (area[x][y].type==0) {
          if (y>0) {
            cnt=_this.fallPiecesRecursion(area,x,y-1,cnt)+1;
            
          } else {
            _thread.retVal=- _this.h;return;
            
            
          }
          
        }
        _thread.retVal=cnt;return;
        
        
        _thread.retVal=_this;return;
      },
      matching :function _trc_Board_matching() {
        "use strict";
        var _this=this;
        var i;
        var j;
        var eraseXYs;
        var totalErases;
        var c;
        
        _this.chkArea=[];
        i = 0;
        for (; i<_this.area.length ; i++) {
          Tonyu.checkLoop();
          {
            _this.chkArea[i]=[];
            j = 0;
            for (; j<_this.area[i].length ; j++) {
              Tonyu.checkLoop();
              {
                _this.chkArea[i][j]=0;
              }
            }
          }
        }
        eraseXYs = [];
        
        totalErases = 0;
        
        i = 0;
        for (; i<_this.area.length ; i++) {
          Tonyu.checkLoop();
          {
            j = 0;
            for (; j<_this.area[i].length ; j++) {
              Tonyu.checkLoop();
              {
                if (! _this.chkArea[i][j]&&_this.area[i][j]&&_this.area[i][j].type!=0) {
                  c = _this.matchingRecursion(_this.area,i,j,[]);
                  
                  if (c.length>=_this.eraseAmount) {
                    totalErases+=c.length;
                    eraseXYs.push([_this.area[i][j].type,c]);
                    
                  }
                  
                }
              }
            }
          }
        }
        return eraseXYs;
      },
      fiber$matching :function _trc_Board_f_matching(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        var j;
        var eraseXYs;
        var totalErases;
        var c;
        
        _this.chkArea=[];
        i = 0;
        for (; i<_this.area.length ; i++) {
          Tonyu.checkLoop();
          {
            _this.chkArea[i]=[];
            j = 0;
            for (; j<_this.area[i].length ; j++) {
              Tonyu.checkLoop();
              {
                _this.chkArea[i][j]=0;
              }
            }
          }
        }
        eraseXYs = [];
        
        totalErases = 0;
        
        
        _thread.enter(function _trc_Board_ent_matching(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              i = 0;
              
            case 1:
              if (!(i<_this.area.length)) { __pc=8     ; break; }
              j = 0;
              
            case 2:
              if (!(j<_this.area[i].length)) { __pc=6     ; break; }
              if (!(! _this.chkArea[i][j]&&_this.area[i][j]&&_this.area[i][j].type!=0)) { __pc=4     ; break; }
              _this.fiber$matchingRecursion(_thread, _this.area, i, j, []);
              __pc=3;return;
            case 3:
              c=_thread.retVal;
              
              if (c.length>=_this.eraseAmount) {
                totalErases+=c.length;
                eraseXYs.push([_this.area[i][j].type,c]);
                
              }
            case 4     :
              
            case 5     :
              j++;
              __pc=2;break;
            case 6     :
              
            case 7     :
              i++;
              __pc=1;break;
            case 8     :
              
              _thread.exit(eraseXYs);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      erase :function _trc_Board_erase(eraseXYs) {
        "use strict";
        var _this=this;
        var totalErases;
        var ex;
        var ey;
        var li;
        var i;
        var bounus;
        var tscore;
        
        totalErases = 0;
        
        
        li = 0;
        for (; li<eraseXYs.length ; li++) {
          Tonyu.checkLoop();
          {
            _this.eraseType=eraseXYs[li][0];
            _this.eraseMassPiece=eraseXYs[li][1];
            totalErases+=_this.eraseMassPiece.length;
            _this.collect(_this.eraseType,_this.eraseMassPiece.length);
            i = 0;
            for (; i<_this.eraseMassPiece.length ; i++) {
              Tonyu.checkLoop();
              {
                ex=_this.eraseMassPiece[i][0];
                ey=_this.eraseMassPiece[i][1];
                if (_this.area[ex][ey]) {
                  _this.area[ex][ey].erase();
                  
                }
              }
            }
          }
        }
        bounus = _this.floor(Tonyu.globals.$Math.pow(1.2,totalErases)*2)/2;
        
        tscore = _this.floor(totalErases*Tonyu.globals.$Math.pow(2,_this.combo)*bounus);
        
        _this.pointScore+=tscore;
        _this.comboScoreSum+=tscore;
        _this.textObjB.text=totalErases+" * "+Tonyu.globals.$Math.pow(2,_this.combo)+" * "+bounus+" = "+tscore;
      },
      fiber$erase :function _trc_Board_f_erase(_thread,eraseXYs) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var totalErases;
        var ex;
        var ey;
        var li;
        var i;
        var bounus;
        var tscore;
        
        totalErases = 0;
        
        
        
        _thread.enter(function _trc_Board_ent_erase(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              li = 0;
              
            case 1:
              if (!(li<eraseXYs.length)) { __pc=4     ; break; }
              _this.eraseType=eraseXYs[li][0];
              _this.eraseMassPiece=eraseXYs[li][1];
              totalErases+=_this.eraseMassPiece.length;
              _this.fiber$collect(_thread, _this.eraseType, _this.eraseMassPiece.length);
              __pc=2;return;
            case 2:
              
              i = 0;
              for (; i<_this.eraseMassPiece.length ; i++) {
                Tonyu.checkLoop();
                {
                  ex=_this.eraseMassPiece[i][0];
                  ey=_this.eraseMassPiece[i][1];
                  if (_this.area[ex][ey]) {
                    _this.area[ex][ey].erase();
                    
                  }
                }
              }
            case 3     :
              li++;
              __pc=1;break;
            case 4     :
              
              bounus = _this.floor(Tonyu.globals.$Math.pow(1.2,totalErases)*2)/2;
              
              tscore = _this.floor(totalErases*Tonyu.globals.$Math.pow(2,_this.combo)*bounus);
              
              _this.pointScore+=tscore;
              _this.comboScoreSum+=tscore;
              _this.textObjB.text=totalErases+" * "+Tonyu.globals.$Math.pow(2,_this.combo)+" * "+bounus+" = "+tscore;
              _thread.exit(_this);return;
            }
          }
        });
      },
      matchingRecursion :function _trc_Board_matchingRecursion(area,x,y,checks) {
        "use strict";
        var _this=this;
        var type;
        
        if (_this.chkArea[x][y]) {
          return checks;
        }
        type = area[x][y].type;
        
        _this.chkArea[x][y]=1;
        checks.push([x,y]);
        if (x>0) {
          if (type==area[x-1][y].type) {
            checks=_this.matchingRecursion(area,x-1,y,checks);
          }
          
        }
        if (x<_this.w-1) {
          if (type==area[x+1][y].type) {
            checks=_this.matchingRecursion(area,x+1,y,checks);
          }
          
        }
        if (y>0) {
          if (type==area[x][y-1].type) {
            checks=_this.matchingRecursion(area,x,y-1,checks);
          }
          
        }
        if (y<_this.h-1) {
          if (type==area[x][y+1].type) {
            checks=_this.matchingRecursion(area,x,y+1,checks);
          }
          
        }
        return checks;
      },
      fiber$matchingRecursion :function _trc_Board_f_matchingRecursion(_thread,area,x,y,checks) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var type;
        
        if (_this.chkArea[x][y]) {
          _thread.retVal=checks;return;
          
        }
        type = area[x][y].type;
        
        _this.chkArea[x][y]=1;
        checks.push([x,y]);
        
        _thread.enter(function _trc_Board_ent_matchingRecursion(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(x>0)) { __pc=3     ; break; }
              if (!(type==area[x-1][y].type)) { __pc=2     ; break; }
              _this.fiber$matchingRecursion(_thread, area, x-1, y, checks);
              __pc=1;return;
            case 1:
              checks=_thread.retVal;
              
            case 2     :
              
            case 3     :
              
              if (!(x<_this.w-1)) { __pc=6     ; break; }
              if (!(type==area[x+1][y].type)) { __pc=5     ; break; }
              _this.fiber$matchingRecursion(_thread, area, x+1, y, checks);
              __pc=4;return;
            case 4:
              checks=_thread.retVal;
              
            case 5     :
              
            case 6     :
              
              if (!(y>0)) { __pc=9     ; break; }
              if (!(type==area[x][y-1].type)) { __pc=8     ; break; }
              _this.fiber$matchingRecursion(_thread, area, x, y-1, checks);
              __pc=7;return;
            case 7:
              checks=_thread.retVal;
              
            case 8     :
              
            case 9     :
              
              if (!(y<_this.h-1)) { __pc=12    ; break; }
              if (!(type==area[x][y+1].type)) { __pc=11    ; break; }
              _this.fiber$matchingRecursion(_thread, area, x, y+1, checks);
              __pc=10;return;
            case 10:
              checks=_thread.retVal;
              
            case 11    :
              
            case 12    :
              
              _thread.exit(checks);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      eraseRecursion :function _trc_Board_eraseRecursion(area,checks) {
        "use strict";
        var _this=this;
        
      },
      fiber$eraseRecursion :function _trc_Board_f_eraseRecursion(_thread,area,checks) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      matchingReady :function _trc_Board_matchingReady() {
        "use strict";
        var _this=this;
        
        _this.doMatching=1;
        _this.doSave=1;
      },
      fiber$matchingReady :function _trc_Board_f_matchingReady(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.doMatching=1;
        _this.doSave=1;
        
        _thread.retVal=_this;return;
      },
      save :function _trc_Board_save() {
        "use strict";
        var _this=this;
        var tc;
        var ar;
        var i;
        var j;
        
        tc = Tonyu.globals.$turnCnt;
        
        ar = [];
        
        i = 0;
        for (; i<_this.area.length ; i++) {
          Tonyu.checkLoop();
          {
            ar[i]=[];
            j = 0;
            for (; j<_this.area[i].length ; j++) {
              Tonyu.checkLoop();
              {
                ar[i][j]={};
                ar[i][j]["obj"]=_this.area[i][j];
                ar[i][j]["type"]=_this.area[i][j].type;
              }
            }
          }
        }
        _this.areaSaves.push([ar,tc]);
        _this.saveInfo.push({pointScore: _this.pointScore,collectScore: _this.collectScore.concat([]),nextTypeStackCnt: _this.nextTypeStackCnt});
        _this.turnCntTextObj.text="Turn: "+_this.areaSaves.length;
      },
      fiber$save :function _trc_Board_f_save(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var tc;
        var ar;
        var i;
        var j;
        
        tc = Tonyu.globals.$turnCnt;
        
        ar = [];
        
        i = 0;
        for (; i<_this.area.length ; i++) {
          Tonyu.checkLoop();
          {
            ar[i]=[];
            j = 0;
            for (; j<_this.area[i].length ; j++) {
              Tonyu.checkLoop();
              {
                ar[i][j]={};
                ar[i][j]["obj"]=_this.area[i][j];
                ar[i][j]["type"]=_this.area[i][j].type;
              }
            }
          }
        }
        _this.areaSaves.push([ar,tc]);
        _this.saveInfo.push({pointScore: _this.pointScore,collectScore: _this.collectScore.concat([]),nextTypeStackCnt: _this.nextTypeStackCnt});
        _this.turnCntTextObj.text="Turn: "+_this.areaSaves.length;
        
        _thread.retVal=_this;return;
      },
      back :function _trc_Board_back() {
        "use strict";
        var _this=this;
        var as;
        var info;
        
        _this.doMatching=0;
        _this.lockTime=0;
        _this.moveLock=0;
        if (_this.areaSaves.length<=1) {
          return false;
        }
        _this.areaSaves.pop();
        _this.saveInfo.pop();
        as = _this.areaSaves[_this.areaSaves.length-1];
        
        info = _this.saveInfo[_this.saveInfo.length-1];
        
        _this.pointScore=info["pointScore"];
        _this.collectScore=info["collectScore"].concat([]);
        _this.nextTypeStackCnt=info["nextTypeStackCnt"];
        _this.turnCntTextObj.text="Turn: "+_this.areaSaves.length;
        _this.scoreUpd();
        return _this.reposition(as);
      },
      fiber$back :function _trc_Board_f_back(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var as;
        var info;
        
        _this.doMatching=0;
        _this.lockTime=0;
        _this.moveLock=0;
        if (_this.areaSaves.length<=1) {
          _thread.retVal=false;return;
          
        }
        _this.areaSaves.pop();
        _this.saveInfo.pop();
        as = _this.areaSaves[_this.areaSaves.length-1];
        
        info = _this.saveInfo[_this.saveInfo.length-1];
        
        _this.pointScore=info["pointScore"];
        _this.collectScore=info["collectScore"].concat([]);
        _this.nextTypeStackCnt=info["nextTypeStackCnt"];
        _this.turnCntTextObj.text="Turn: "+_this.areaSaves.length;
        
        _thread.enter(function _trc_Board_ent_back(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$scoreUpd(_thread);
              __pc=1;return;
            case 1:
              
              _this.fiber$reposition(_thread, as);
              __pc=2;return;
            case 2:
              _thread.exit(_thread.retVal);return;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      reposition :function _trc_Board_reposition(repos) {
        "use strict";
        var _this=this;
        var na;
        var i;
        var j;
        
        na = repos[0];
        
        Tonyu.globals.$turnCnt=repos[1];
        i = 0;
        for (; i<na.length ; i++) {
          Tonyu.checkLoop();
          {
            j = 0;
            for (; j<na[i].length ; j++) {
              Tonyu.checkLoop();
              {
                if (na[i][j]["obj"]) {
                  na[i][j]["obj"].reposition(i,j);
                  na[i][j]["obj"].type=na[i][j]["type"];
                  
                }
                _this.area[i][j]=na[i][j]["obj"];
              }
            }
          }
        }
        return true;
      },
      fiber$reposition :function _trc_Board_f_reposition(_thread,repos) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var na;
        var i;
        var j;
        
        na = repos[0];
        
        Tonyu.globals.$turnCnt=repos[1];
        i = 0;
        for (; i<na.length ; i++) {
          Tonyu.checkLoop();
          {
            j = 0;
            for (; j<na[i].length ; j++) {
              Tonyu.checkLoop();
              {
                if (na[i][j]["obj"]) {
                  na[i][j]["obj"].reposition(i,j);
                  na[i][j]["obj"].type=na[i][j]["type"];
                  
                }
                _this.area[i][j]=na[i][j]["obj"];
              }
            }
          }
        }
        _thread.retVal=true;return;
        
        
        _thread.retVal=_this;return;
      },
      mapload :function _trc_Board_mapload() {
        "use strict";
        var _this=this;
        var i;
        var j;
        var pa;
        var piece;
        
        Tonyu.globals.$map=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$map.load("map.json");
        _this.w=Tonyu.globals.$map.col;
        _this.h=Tonyu.globals.$map.row;
        _this.area=[];
        i = 0;
        for (; i<_this.w ; i++) {
          Tonyu.checkLoop();
          {
            _this.area[i]=[];
            j = 0;
            for (; j<_this.h ; j++) {
              Tonyu.checkLoop();
              {
                pa = Tonyu.globals.$map.get(i,j);
                
                if (pa>=Tonyu.globals.$mapchip["place"][0]&&pa<=Tonyu.globals.$mapchip["place"][1]) {
                  piece = new Tonyu.classes.user.Piece({x: (i+0.5)*Tonyu.globals.$map.chipWidth,y: (j+0.5)*Tonyu.globals.$map.chipHeight,type: 0});
                  
                  _this.area[i][j]=piece;
                  
                } else {
                  _this.area[i][j]=0;
                  
                }
              }
            }
          }
        }
      },
      fiber$mapload :function _trc_Board_f_mapload(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        var j;
        var pa;
        var piece;
        
        Tonyu.globals.$map=new Tonyu.classes.kernel.Map;
        Tonyu.globals.$map.load("map.json");
        _this.w=Tonyu.globals.$map.col;
        _this.h=Tonyu.globals.$map.row;
        _this.area=[];
        i = 0;
        for (; i<_this.w ; i++) {
          Tonyu.checkLoop();
          {
            _this.area[i]=[];
            j = 0;
            for (; j<_this.h ; j++) {
              Tonyu.checkLoop();
              {
                pa = Tonyu.globals.$map.get(i,j);
                
                if (pa>=Tonyu.globals.$mapchip["place"][0]&&pa<=Tonyu.globals.$mapchip["place"][1]) {
                  piece = new Tonyu.classes.user.Piece({x: (i+0.5)*Tonyu.globals.$map.chipWidth,y: (j+0.5)*Tonyu.globals.$map.chipHeight,type: 0});
                  
                  _this.area[i][j]=piece;
                  
                } else {
                  _this.area[i][j]=0;
                  
                }
              }
            }
          }
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"scoreUpd":{"nowait":false},"setNextPiece":{"nowait":false},"fillPiece":{"nowait":false},"collect":{"nowait":false},"makeTempBoard":{"nowait":false},"fallPieces":{"nowait":false},"fallPiecesRecursion":{"nowait":false},"matching":{"nowait":false},"erase":{"nowait":false},"matchingRecursion":{"nowait":false},"eraseRecursion":{"nowait":false},"matchingReady":{"nowait":false},"save":{"nowait":false},"back":{"nowait":false},"reposition":{"nowait":false},"mapload":{"nowait":false}},"fields":{"w":{},"h":{},"area":{},"chkArea":{},"areaSaves":{},"saveInfo":{},"moveLock":{},"pointScore":{},"collectScore":{},"nextTypeStack":{},"maxType":{},"eraseAmount":{},"i":{},"savePos":{},"turnCntTextObj":{},"textObjB":{},"pointScoreTextObj":{},"collectScoreTextObj":{},"rtCnt":{},"nextTypeStackCnt":{},"eraseXYs":{},"combo":{},"comboScoreSum":{},"doSave":{},"doMatching":{},"lockTime":{},"matchCnt":{},"eraseType":{},"eraseMassPiece":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Ctx',
  shortName: 'Ctx',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Ctx_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Ctx_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      fillRect :function _trc_Ctx_fillRect(ctx,x,y,w,h,scale) {
        "use strict";
        var _this=this;
        var wsize;
        var hsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        ctx.fill();
      },
      rect :function _trc_Ctx_rect(ctx,x,y,w,h,scale,isFill) {
        "use strict";
        var _this=this;
        var wsize;
        var hsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$rect :function _trc_Ctx_f_rect(_thread,ctx,x,y,w,h,scale,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var wsize;
        var hsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      rectFrame :function _trc_Ctx_rectFrame(ctx,x,y,w,h,iw,ih,scale,isFill) {
        "use strict";
        var _this=this;
        var wsize;
        var hsize;
        var iwsize;
        var ihsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        iwsize = iw*scale;
        
        ihsize = ih*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        ctx.moveTo(x-iwsize/2,y-ihsize/2);
        ctx.lineTo(x+iwsize/2,y-ihsize/2);
        ctx.lineTo(x+iwsize/2,y+ihsize/2);
        ctx.lineTo(x-iwsize/2,y+ihsize/2);
        ctx.lineTo(x-iwsize/2,y-ihsize/2);
        ctx.fill("evenodd");
      },
      fiber$rectFrame :function _trc_Ctx_f_rectFrame(_thread,ctx,x,y,w,h,iw,ih,scale,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var wsize;
        var hsize;
        var iwsize;
        var ihsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        iwsize = iw*scale;
        
        ihsize = ih*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        ctx.moveTo(x-iwsize/2,y-ihsize/2);
        ctx.lineTo(x+iwsize/2,y-ihsize/2);
        ctx.lineTo(x+iwsize/2,y+ihsize/2);
        ctx.lineTo(x-iwsize/2,y+ihsize/2);
        ctx.lineTo(x-iwsize/2,y-ihsize/2);
        ctx.fill("evenodd");
        
        _thread.retVal=_this;return;
      },
      triangle :function _trc_Ctx_triangle(ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        
        ctx.beginPath();
        ctx.moveTo(x,y-size/2);
        ctx.lineTo(x+size/2,y+size/2);
        ctx.lineTo(x-size/2,y+size/2);
        ctx.lineTo(x,y-size/2);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$triangle :function _trc_Ctx_f_triangle(_thread,ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        ctx.beginPath();
        ctx.moveTo(x,y-size/2);
        ctx.lineTo(x+size/2,y+size/2);
        ctx.lineTo(x-size/2,y+size/2);
        ctx.lineTo(x,y-size/2);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      circle :function _trc_Ctx_circle(ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        
        ctx.beginPath();
        ctx.arc(x,y,size/2,0,Tonyu.globals.$Math.PI*2,true);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$circle :function _trc_Ctx_f_circle(_thread,ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        ctx.beginPath();
        ctx.arc(x,y,size/2,0,Tonyu.globals.$Math.PI*2,true);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      moon :function _trc_Ctx_moon(ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        var startAngle;
        var endAngle;
        
        startAngle = 270*Tonyu.globals.$Math.PI/180;
        
        endAngle = 180*Tonyu.globals.$Math.PI/180;
        
        ctx.beginPath();
        ctx.arc(x,y,size/2,startAngle,endAngle,false);
        ctx.arc(x-size/5,y-size/5,size/3,endAngle,startAngle,true);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$moon :function _trc_Ctx_f_moon(_thread,ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var startAngle;
        var endAngle;
        
        startAngle = 270*Tonyu.globals.$Math.PI/180;
        
        endAngle = 180*Tonyu.globals.$Math.PI/180;
        
        ctx.beginPath();
        ctx.arc(x,y,size/2,startAngle,endAngle,false);
        ctx.arc(x-size/5,y-size/5,size/3,endAngle,startAngle,true);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      sparkle :function _trc_Ctx_sparkle(ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        var startAngle;
        var endAngle;
        
        startAngle = 270*Tonyu.globals.$Math.PI/180;
        
        endAngle = 180*Tonyu.globals.$Math.PI/180;
        
        size/=1.75;
        _this.qsize=size/4;
        ctx.beginPath();
        ctx.moveTo(x-size,y);
        ctx.quadraticCurveTo(x-_this.qsize,y-_this.qsize,x,y-size);
        ctx.quadraticCurveTo(x+_this.qsize,y-_this.qsize,x+size,y);
        ctx.quadraticCurveTo(x+_this.qsize,y+_this.qsize,x,y+size);
        ctx.quadraticCurveTo(x-_this.qsize,y+_this.qsize,x-size,y);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$sparkle :function _trc_Ctx_f_sparkle(_thread,ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var startAngle;
        var endAngle;
        
        startAngle = 270*Tonyu.globals.$Math.PI/180;
        
        endAngle = 180*Tonyu.globals.$Math.PI/180;
        
        size/=1.75;
        _this.qsize=size/4;
        ctx.beginPath();
        ctx.moveTo(x-size,y);
        ctx.quadraticCurveTo(x-_this.qsize,y-_this.qsize,x,y-size);
        ctx.quadraticCurveTo(x+_this.qsize,y-_this.qsize,x+size,y);
        ctx.quadraticCurveTo(x+_this.qsize,y+_this.qsize,x,y+size);
        ctx.quadraticCurveTo(x-_this.qsize,y+_this.qsize,x-size,y);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      rgba :function _trc_Ctx_rgba(r,g,b,a) {
        "use strict";
        var _this=this;
        
        return "rgba("+r+","+g+","+b+", "+a+")";
      },
      fiber$rgba :function _trc_Ctx_f_rgba(_thread,r,g,b,a) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal="rgba("+r+","+g+","+b+", "+a+")";return;
        
        
        _thread.retVal=_this;return;
      },
      rgbaString :function _trc_Ctx_rgbaString(color) {
        "use strict";
        var _this=this;
        
        return "rgba("+color.r+","+color.g+","+color.b+", "+color.a+")";
      },
      fiber$rgbaString :function _trc_Ctx_f_rgbaString(_thread,color) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal="rgba("+color.r+","+color.g+","+color.b+", "+color.a+")";return;
        
        
        _thread.retVal=_this;return;
      },
      color :function _trc_Ctx_color(r,g,b,a) {
        "use strict";
        var _this=this;
        var col;
        
        col = {};
        
        col.r=r;
        col.g=g;
        col.b=b;
        col.a=a;
        return col;
      },
      colorMix :function _trc_Ctx_colorMix(colA,colB,rate) {
        "use strict";
        var _this=this;
        var ar;
        var br;
        var colC;
        
        ar = 1-rate;
        
        br = rate;
        
        colC = {};
        
        colC.r=colA.r*ar+colB.r*br;
        colC.g=colA.g*ar+colB.g*br;
        colC.b=colA.b*ar+colB.b*br;
        colC.a=colA.a*ar+colB.a*br;
        return colC;
      },
      fiber$colorMix :function _trc_Ctx_f_colorMix(_thread,colA,colB,rate) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var ar;
        var br;
        var colC;
        
        ar = 1-rate;
        
        br = rate;
        
        colC = {};
        
        colC.r=colA.r*ar+colB.r*br;
        colC.g=colA.g*ar+colB.g*br;
        colC.b=colA.b*ar+colB.b*br;
        colC.a=colA.a*ar+colB.a*br;
        _thread.retVal=colC;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"fillRect":{"nowait":true},"rect":{"nowait":false},"rectFrame":{"nowait":false},"triangle":{"nowait":false},"circle":{"nowait":false},"moon":{"nowait":false},"sparkle":{"nowait":false},"rgba":{"nowait":false},"rgbaString":{"nowait":false},"color":{"nowait":true},"colorMix":{"nowait":false}},"fields":{"qsize":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Ease',
  shortName: 'Ease',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Ease_main() {
        "use strict";
        var _this=this;
        
        _this.type = [];
        
        _this.type[1]=Tonyu.bindFunc(_this,_this.linear);
        _this.type[14]=Tonyu.bindFunc(_this,_this.easeInQuart);
        _this.type[15]=Tonyu.bindFunc(_this,_this.easeOutQuart);
        _this.type[22]=Tonyu.bindFunc(_this,_this.easeInExpo);
        _this.type[23]=Tonyu.bindFunc(_this,_this.easeOutExpo);
        ;
        
        ;
        
        ;
        
        ;
        
        ;
        
      },
      fiber$main :function _trc_Ease_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.type = [];
        
        _this.type[1]=Tonyu.bindFunc(_this,_this.linear);
        _this.type[14]=Tonyu.bindFunc(_this,_this.easeInQuart);
        _this.type[15]=Tonyu.bindFunc(_this,_this.easeOutQuart);
        _this.type[22]=Tonyu.bindFunc(_this,_this.easeInExpo);
        _this.type[23]=Tonyu.bindFunc(_this,_this.easeOutExpo);
        ;
        
        ;
        
        ;
        
        ;
        
        ;
        
        
        _thread.retVal=_this;return;
      },
      linear :function _trc_Ease_linear(t,b,c,d) {
        "use strict";
        var _this=this;
        
        return c*t/d+b;
      },
      fiber$linear :function _trc_Ease_f_linear(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=c*t/d+b;return;
        
        
        _thread.retVal=_this;return;
      },
      easeInQuart :function _trc_Ease_easeInQuart(t,b,c,d) {
        "use strict";
        var _this=this;
        
        t/=d;
        return c*t*t*t*t+b;
      },
      fiber$easeInQuart :function _trc_Ease_f_easeInQuart(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        t/=d;
        _thread.retVal=c*t*t*t*t+b;return;
        
        
        _thread.retVal=_this;return;
      },
      easeOutQuart :function _trc_Ease_easeOutQuart(t,b,c,d) {
        "use strict";
        var _this=this;
        
        t/=d;
        t--;
        return - c*(t*t*t*t-1)+b;
      },
      fiber$easeOutQuart :function _trc_Ease_f_easeOutQuart(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        t/=d;
        t--;
        _thread.retVal=- c*(t*t*t*t-1)+b;return;
        
        
        _thread.retVal=_this;return;
      },
      easeInExpo :function _trc_Ease_easeInExpo(t,b,c,d) {
        "use strict";
        var _this=this;
        
        return c*Tonyu.globals.$Math.pow(2,10*(t/d-1))+b;
      },
      fiber$easeInExpo :function _trc_Ease_f_easeInExpo(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=c*Tonyu.globals.$Math.pow(2,10*(t/d-1))+b;return;
        
        
        _thread.retVal=_this;return;
      },
      easeOutExpo :function _trc_Ease_easeOutExpo(t,b,c,d) {
        "use strict";
        var _this=this;
        
        return c*(- Tonyu.globals.$Math.pow(2,- 10*t/d)+1)+b;
      },
      fiber$easeOutExpo :function _trc_Ease_f_easeOutExpo(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=c*(- Tonyu.globals.$Math.pow(2,- 10*t/d)+1)+b;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"linear":{"nowait":false},"easeInQuart":{"nowait":false},"easeOutQuart":{"nowait":false},"easeInExpo":{"nowait":false},"easeOutExpo":{"nowait":false}},"fields":{"type":{}}}
});
Tonyu.klass.define({
  fullName: 'user.GameMain',
  shortName: 'GameMain',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GameMain_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Board;
        _this.GameInit();
        Tonyu.globals.$dragPiece=false;
        Tonyu.globals.$turnCnt=0;
        _this.turnTextObj = new Tonyu.classes.kernel.Actor({x: 0,y: 0,text: "move:0",align: "left"});
        
        _this.backBtn = new Tonyu.classes.kernel.Button({text: "undo",top: 0,left: 260,height: 20,width: 60,onClick: (function anonymous_204() {
          
          if (! Tonyu.globals.$Board.back()) {
            _this.backBtn.left+=_this.rnd(11)-5;
          }
        })});
        
        while (1) {
          Tonyu.checkLoop();
          _this.turnTextObj.text="move: "+Tonyu.globals.$turnCnt;
          _this.update();
          
        }
      },
      fiber$main :function _trc_GameMain_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Board;
        
        _thread.enter(function _trc_GameMain_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$GameInit(_thread);
              __pc=1;return;
            case 1:
              
              Tonyu.globals.$dragPiece=false;
              Tonyu.globals.$turnCnt=0;
              _this.turnTextObj = new Tonyu.classes.kernel.Actor({x: 0,y: 0,text: "move:0",align: "left"});
              
              _this.backBtn = new Tonyu.classes.kernel.Button({text: "undo",top: 0,left: 260,height: 20,width: 60,onClick: (function anonymous_204() {
                
                if (! Tonyu.globals.$Board.back()) {
                  _this.backBtn.left+=_this.rnd(11)-5;
                }
              })});
              
            case 2:
              if (!(1)) { __pc=4     ; break; }
              _this.turnTextObj.text="move: "+Tonyu.globals.$turnCnt;
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
              __pc=2;break;
            case 4     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      GameInit :function _trc_GameMain_GameInit() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Board=new Tonyu.classes.user.Board();
      },
      fiber$GameInit :function _trc_GameMain_f_GameInit(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Board=new Tonyu.classes.user.Board();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"GameInit":{"nowait":false}},"fields":{"turnTextObj":{},"backBtn":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Screen.resize(320,320+64);
        Tonyu.globals.$mapchip={};
        Tonyu.globals.$mapchip["place"]=[Tonyu.globals.$pat_mapchip,Tonyu.globals.$pat_mapchip+7];
        Tonyu.globals.$ctx=new Tonyu.classes.user.Ctx();
        Tonyu.globals.$ease=new Tonyu.classes.user.Ease();
        new Tonyu.classes.user.GameMain();
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Screen.resize(320,320+64);
        Tonyu.globals.$mapchip={};
        Tonyu.globals.$mapchip["place"]=[Tonyu.globals.$pat_mapchip,Tonyu.globals.$pat_mapchip+7];
        Tonyu.globals.$ctx=new Tonyu.classes.user.Ctx();
        Tonyu.globals.$ease=new Tonyu.classes.user.Ease();
        new Tonyu.classes.user.GameMain();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Piece',
  shortName: 'Piece',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Piece_main() {
        "use strict";
        var _this=this;
        
        _this.p=Tonyu.globals.$pat_piece+_this.type-1;
        _this.dragEnd = 0;
        
        _this.moveEnd = 0;
        
        _this.doMove = false;
        
        _this.doSave = 0;
        
        _this.doEraseLoop = false;
        
        _this.moveLock = false;
        
        _this.px = _this.floor(_this.x/32);
        
        _this.py = _this.floor(_this.y/32);
        
        
        _this.animTime = _this.px*4+_this.py*6;
        
        _this.scaleX = 1;
        
        _this.isDragging = 0;
        
        _this.eScale=1;
        _this.color = {r: (255-_this.x*_this.y/(320*320)*255),g: _this.x/320*231+24,b: _this.y/320*231+24,a: 0.3};
        
        while (true) {
          Tonyu.checkLoop();
          if (_this.doMove) {
            _this.moveLoop();
          }
          if (_this.doEraseLoop) {
            _this.eraseLoop();
          }
          if (! Tonyu.globals.$Board.moveLock) {
            _this.t=Tonyu.globals.$touches[0];
            if (_this.t.x>=_this.x-16&&_this.t.x<=_this.x+16&&_this.t.y>=_this.y-16&&_this.t.y<=_this.y+16) {
              if (_this.t&&_this.t.touched==1&&! Tonyu.globals.$dragPiece&&! _this.doMove) {
                if (Tonyu.globals.$dragPiece) {
                  Tonyu.globals.$dragPiece.dragEnd=1;
                }
                Tonyu.globals.$dragPiece=_this;
                do {
                  Tonyu.checkLoop();
                  _this.dragEnd=0;
                  _this.drag(_this.t);
                  if (! _this.t.ended) {
                    _this.update();
                  }
                  
                } while (! _this.t.ended);
                
                Tonyu.globals.$dragPiece=false;
                if (_this.doSave) {
                  Tonyu.globals.$Board.matchingReady();
                  _this.doSave=0;
                  
                }
                
              }
            }
            
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_Piece_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.p=Tonyu.globals.$pat_piece+_this.type-1;
        _this.dragEnd = 0;
        
        _this.moveEnd = 0;
        
        _this.doMove = false;
        
        _this.doSave = 0;
        
        _this.doEraseLoop = false;
        
        _this.moveLock = false;
        
        _this.px = _this.floor(_this.x/32);
        
        _this.py = _this.floor(_this.y/32);
        
        
        _this.animTime = _this.px*4+_this.py*6;
        
        _this.scaleX = 1;
        
        _this.isDragging = 0;
        
        _this.eScale=1;
        _this.color = {r: (255-_this.x*_this.y/(320*320)*255),g: _this.x/320*231+24,b: _this.y/320*231+24,a: 0.3};
        
        
        _thread.enter(function _trc_Piece_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.doMove)) { __pc=3     ; break; }
              _this.fiber$moveLoop(_thread);
              __pc=2;return;
            case 2:
              
            case 3     :
              
              if (!(_this.doEraseLoop)) { __pc=5     ; break; }
              _this.fiber$eraseLoop(_thread);
              __pc=4;return;
            case 4:
              
            case 5     :
              
              if (!(! Tonyu.globals.$Board.moveLock)) { __pc=14    ; break; }
              _this.t=Tonyu.globals.$touches[0];
              if (!(_this.t.x>=_this.x-16&&_this.t.x<=_this.x+16&&_this.t.y>=_this.y-16&&_this.t.y<=_this.y+16)) { __pc=13    ; break; }
              if (!(_this.t&&_this.t.touched==1&&! Tonyu.globals.$dragPiece&&! _this.doMove)) { __pc=12    ; break; }
              if (Tonyu.globals.$dragPiece) {
                Tonyu.globals.$dragPiece.dragEnd=1;
              }
              Tonyu.globals.$dragPiece=_this;
            case 6:
              _this.dragEnd=0;
              _this.fiber$drag(_thread, _this.t);
              __pc=7;return;
            case 7:
              
              if (!(! _this.t.ended)) { __pc=9     ; break; }
              _this.fiber$update(_thread);
              __pc=8;return;
            case 8:
              
            case 9     :
              
            case 10    :
              if (! _this.t.ended) { __pc=6; break; }
            case 11    :
              
              Tonyu.globals.$dragPiece=false;
              if (_this.doSave) {
                Tonyu.globals.$Board.matchingReady();
                _this.doSave=0;
                
              }
            case 12    :
              
            case 13    :
              
            case 14    :
              
              _this.fiber$update(_thread);
              __pc=15;return;
            case 15:
              
              __pc=1;break;
            case 16    :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      draw :function _trc_Piece_draw(ctx) {
        "use strict";
        var _this=this;
        var scale;
        var size;
        var white;
        
        scale = _this.scaleX;
        
        if (_this.isDragging>0) {
          scale*=1+_this.isDragging/15;
        }
        size = 15+_this.cos(_this.animTime/300*360)*3;
        
        ctx.fillStyle=Tonyu.globals.$ctx.rgba(255,255,255,0.9);
        Tonyu.globals.$ctx.rectFrame(ctx,_this.x,_this.y,28,28,20,20,scale);
        ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.bindFunc(_this,_this.color));
        Tonyu.globals.$ctx.rect(ctx,_this.x,_this.y,20,20,scale,true);
        ctx.strokeStyle=Tonyu.globals.$ctx.rgba(48,48,48,1);
        white = Tonyu.globals.$ctx.color(255,255,255,0.7);
        
        if (_this.type==1) {
          ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(255,42,32,0.7),white,0));
          Tonyu.globals.$ctx.circle(ctx,_this.x,_this.y,size*scale,true);
          Tonyu.globals.$ctx.circle(ctx,_this.x,_this.y,size*scale,false);
          
        } else {
          if (_this.type==2) {
            ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(98,112,185,0.7),white,0));
            Tonyu.globals.$ctx.rect(ctx,_this.x,_this.y,size,size,scale,true);
            Tonyu.globals.$ctx.rect(ctx,_this.x,_this.y,size,size,scale,false);
            
          } else {
            if (_this.type==3) {
              ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(15,232,20,0.7),white,0));
              Tonyu.globals.$ctx.triangle(ctx,_this.x,_this.y,size*scale,true);
              Tonyu.globals.$ctx.triangle(ctx,_this.x,_this.y,size*scale,false);
              
            } else {
              if (_this.type==4) {
                ctx.strokeStyle=Tonyu.globals.$ctx.rgba(60,60,60,0.5);
                ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(252,252,18,0.85),white,0));
                Tonyu.globals.$ctx.moon(ctx,_this.x,_this.y,size*scale,true);
                Tonyu.globals.$ctx.moon(ctx,_this.x,_this.y,size*scale,false);
                
              } else {
                if (_this.type==5) {
                  ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(180,5,180,0.7),white,0));
                  Tonyu.globals.$ctx.sparkle(ctx,_this.x,_this.y,size*scale,true);
                  Tonyu.globals.$ctx.sparkle(ctx,_this.x,_this.y,size*scale,false);
                  
                }
              }
            }
          }
        }
      },
      onUpdate :function _trc_Piece_onUpdate() {
        "use strict";
        var _this=this;
        
        _this.animTime++;
        _this.isDragging--;
      },
      erase :function _trc_Piece_erase() {
        "use strict";
        var _this=this;
        
        new Tonyu.classes.user.PieceEffect({x: _this.x,y: _this.y,color: Object.create(Tonyu.bindFunc(_this,_this.color)),type: _this.type,t: 0.9,maxt: 60,eScale: 0.5,eAlpha: 0,ex: _this.x+(_this.rnd(32)-16)*4,ey: _this.y+(_this.rnd(32)-16)*4});
        _this.type=0;
      },
      fiber$erase :function _trc_Piece_f_erase(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        new Tonyu.classes.user.PieceEffect({x: _this.x,y: _this.y,color: Object.create(Tonyu.bindFunc(_this,_this.color)),type: _this.type,t: 0.9,maxt: 60,eScale: 0.5,eAlpha: 0,ex: _this.x+(_this.rnd(32)-16)*4,ey: _this.y+(_this.rnd(32)-16)*4});
        _this.type=0;
        
        _thread.retVal=_this;return;
      },
      onDie :function _trc_Piece_onDie() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Board.area[_this.px][_this.py]=0;
      },
      fiber$onDie :function _trc_Piece_f_onDie(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Board.area[_this.px][_this.py]=0;
        
        _thread.retVal=_this;return;
      },
      eraseLoop :function _trc_Piece_eraseLoop() {
        "use strict";
        var _this=this;
        
        _this.hide();
        while (! _this.doMove||_this.type==0) {
          Tonyu.checkLoop();
          _this.update();
          
        }
        _this.doEraseLoop=0;
        _this.show();
      },
      fiber$eraseLoop :function _trc_Piece_f_eraseLoop(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.hide();
        
        _thread.enter(function _trc_Piece_ent_eraseLoop(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(! _this.doMove||_this.type==0)) { __pc=3     ; break; }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.doEraseLoop=0;
              _this.show();
              _thread.exit(_this);return;
            }
          }
        });
      },
      moveLoop :function _trc_Piece_moveLoop() {
        "use strict";
        var _this=this;
        var time;
        var maxt;
        var tk;
        var sx;
        var ax;
        var sy;
        var ay;
        var sScale;
        var aScale;
        
        do {
          Tonyu.checkLoop();
          _this.doMove=false;
          time = _this.esTime;
          
          maxt = _this.eTime;
          
          tk = 0;
          
          sx = _this.x;
          
          ax = _this.ex-sx;
          
          sy = _this.y;
          
          ay = _this.ey-sy;
          
          sScale = _this.scaleX;
          
          aScale = _this.eScale-sScale;
          
          while (time<maxt) {
            Tonyu.checkLoop();
            _this.t=Tonyu.globals.$touches[0];
            if (_this.doMove) {
              break;
              
              
            }
            if (_this.doMove||! Tonyu.globals.$Board.moveLock&&_this.t&&_this.t.x>=_this.x-16&&_this.t.x<=_this.x+16&&_this.t.y>=_this.y-16&&_this.t.y<=_this.y+16&&! _this.t.ended&&! Tonyu.globals.$dragPiece) {
              _this.x=_this.ex;
              _this.y=_this.ey;
              return _this;
              
            }
            tk=1/(1+Tonyu.globals.$Math.pow(2,- 20*(time/maxt)+10));
            _this.x=sx+ax*tk;
            _this.y=sy+ay*tk;
            _this.scaleX=sScale+aScale*tk;
            time++;
            _this.update();
            
          }
          
        } while (_this.doMove);
        
        _this.x=_this.ex;
        _this.y=_this.ey;
        _this.scaleX=_this.eScale;
        _this.moveLock=false;
      },
      fiber$moveLoop :function _trc_Piece_f_moveLoop(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var time;
        var maxt;
        var tk;
        var sx;
        var ax;
        var sy;
        var ay;
        var sScale;
        var aScale;
        
        
        _thread.enter(function _trc_Piece_ent_moveLoop(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.doMove=false;
              time = _this.esTime;
              
              maxt = _this.eTime;
              
              tk = 0;
              
              sx = _this.x;
              
              ax = _this.ex-sx;
              
              sy = _this.y;
              
              ay = _this.ey-sy;
              
              sScale = _this.scaleX;
              
              aScale = _this.eScale-sScale;
              
            case 2:
              if (!(time<maxt)) { __pc=6     ; break; }
              _this.t=Tonyu.globals.$touches[0];
              if (!(_this.doMove)) { __pc=3     ; break; }
              __pc=6     ; break;
              
            case 3     :
              
              if (!(_this.doMove||! Tonyu.globals.$Board.moveLock&&_this.t&&_this.t.x>=_this.x-16&&_this.t.x<=_this.x+16&&_this.t.y>=_this.y-16&&_this.t.y<=_this.y+16&&! _this.t.ended&&! Tonyu.globals.$dragPiece)) { __pc=4     ; break; }
              _this.x=_this.ex;
              _this.y=_this.ey;
              _thread.exit(_this);return;
            case 4     :
              
              tk=1/(1+Tonyu.globals.$Math.pow(2,- 20*(time/maxt)+10));
              _this.x=sx+ax*tk;
              _this.y=sy+ay*tk;
              _this.scaleX=sScale+aScale*tk;
              time++;
              _this.fiber$update(_thread);
              __pc=5;return;
            case 5:
              
              __pc=2;break;
            case 6     :
              
            case 7     :
              if (_this.doMove) { __pc=1; break; }
            case 8     :
              
              _this.x=_this.ex;
              _this.y=_this.ey;
              _this.scaleX=_this.eScale;
              _this.moveLock=false;
              _thread.exit(_this);return;
            }
          }
        });
      },
      moveReady :function _trc_Piece_moveReady(x,y,scale) {
        "use strict";
        var _this=this;
        
        _this.ex=x;
        _this.ey=y;
        _this.eScale=scale;
        _this.eTime=60;
        _this.esTime=30;
        _this.px=_this.floor(x/32);
        _this.py=_this.floor(y/32);
        _this.doMove=true;
        _this.moveLock=true;
      },
      fiber$moveReady :function _trc_Piece_f_moveReady(_thread,x,y,scale) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.ex=x;
        _this.ey=y;
        _this.eScale=scale;
        _this.eTime=60;
        _this.esTime=30;
        _this.px=_this.floor(x/32);
        _this.py=_this.floor(y/32);
        _this.doMove=true;
        _this.moveLock=true;
        
        _thread.retVal=_this;return;
      },
      reposition :function _trc_Piece_reposition(npx,npy) {
        "use strict";
        var _this=this;
        
        _this.moveReady(npx*32+16,npy*32+16,1);
      },
      fiber$reposition :function _trc_Piece_f_reposition(_thread,npx,npy) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Piece_ent_reposition(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$moveReady(_thread, npx*32+16, npy*32+16, 1);
              __pc=1;return;
            case 1:
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      repositionAbs :function _trc_Piece_repositionAbs(npx,npy) {
        "use strict";
        var _this=this;
        
        if (_this.doEraseLoop) {
          _this.doEraseLoop=0;
          _this.show();
          
        }
        _this.x=npx*32+16;
        _this.y=npy*32+16;
        _this.scaleX=0;
        _this.moveReady(npx*32+16,npy*32+16,1);
        _this.eTime=60;
        _this.esTime=15;
      },
      fiber$repositionAbs :function _trc_Piece_f_repositionAbs(_thread,npx,npy) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.doEraseLoop) {
          _this.doEraseLoop=0;
          _this.show();
          
        }
        _this.x=npx*32+16;
        _this.y=npy*32+16;
        _this.scaleX=0;
        
        _thread.enter(function _trc_Piece_ent_repositionAbs(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$moveReady(_thread, npx*32+16, npy*32+16, 1);
              __pc=1;return;
            case 1:
              
              _this.eTime=60;
              _this.esTime=15;
              _thread.exit(_this);return;
            }
          }
        });
      },
      drag :function _trc_Piece_drag(t) {
        "use strict";
        var _this=this;
        var px;
        var py;
        var npx;
        var npy;
        var mp;
        
        px = _this.px;
        
        py = _this.py;
        
        
        while (! t.ended) {
          Tonyu.checkLoop();
          if (_this.dragEnd) {
            break;
            
          }
          _this.x+=t.vx;
          _this.y+=t.vy;
          npx=_this.floor(_this.x/32);
          npy=_this.floor(_this.y/32);
          if ((_this.abs(px-npx)+_this.abs(py-npy))==1) {
            break;
            
          }
          _this.isDragging=15;
          _this.update();
          
        }
        mp = Tonyu.globals.$map.get(npx,npy);
        
        if ((_this.abs(px-npx)+_this.abs(py-npy))==1&&mp>=Tonyu.globals.$mapchip["place"][0]&&mp<=Tonyu.globals.$mapchip["place"][1]) {
          if (Tonyu.globals.$Board.area[npx][npy]) {
            Tonyu.globals.$Board.area[npx][npy].moveReady(px*32+16,py*32+16,1);
            
          }
          _this.moveReady(npx*32+16,npy*32+16,1);
          Tonyu.globals.$Board.area[px][py]=Tonyu.globals.$Board.area[npx][npy];
          Tonyu.globals.$Board.area[npx][npy]=_this;
          Tonyu.globals.$turnCnt++;
          _this.doSave=1;
          
        } else {
          _this.moveReady(px*32+16,py*32+16,1);
          
        }
      },
      fiber$drag :function _trc_Piece_f_drag(_thread,t) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var px;
        var py;
        var npx;
        var npy;
        var mp;
        
        px = _this.px;
        
        py = _this.py;
        
        
        
        _thread.enter(function _trc_Piece_ent_drag(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(! t.ended)) { __pc=5     ; break; }
              if (!(_this.dragEnd)) { __pc=2     ; break; }
              __pc=5     ; break;
              
            case 2     :
              
              _this.x+=t.vx;
              _this.y+=t.vy;
              npx=_this.floor(_this.x/32);
              npy=_this.floor(_this.y/32);
              if (!((_this.abs(px-npx)+_this.abs(py-npy))==1)) { __pc=3     ; break; }
              __pc=5     ; break;
              
            case 3     :
              
              _this.isDragging=15;
              _this.fiber$update(_thread);
              __pc=4;return;
            case 4:
              
              __pc=1;break;
            case 5     :
              
              mp = Tonyu.globals.$map.get(npx,npy);
              
              if (!((_this.abs(px-npx)+_this.abs(py-npy))==1&&mp>=Tonyu.globals.$mapchip["place"][0]&&mp<=Tonyu.globals.$mapchip["place"][1])) { __pc=7     ; break; }
              if (Tonyu.globals.$Board.area[npx][npy]) {
                Tonyu.globals.$Board.area[npx][npy].moveReady(px*32+16,py*32+16,1);
                
              }
              _this.fiber$moveReady(_thread, npx*32+16, npy*32+16, 1);
              __pc=6;return;
            case 6:
              
              Tonyu.globals.$Board.area[px][py]=Tonyu.globals.$Board.area[npx][npy];
              Tonyu.globals.$Board.area[npx][npy]=_this;
              Tonyu.globals.$turnCnt++;
              _this.doSave=1;
              __pc=9     ;break;
            case 7     :
              _this.fiber$moveReady(_thread, px*32+16, py*32+16, 1);
              __pc=8;return;
            case 8:
              
            case 9     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true},"onUpdate":{"nowait":true},"erase":{"nowait":false},"onDie":{"nowait":false},"eraseLoop":{"nowait":false},"moveLoop":{"nowait":false},"moveReady":{"nowait":false},"reposition":{"nowait":false},"repositionAbs":{"nowait":false},"drag":{"nowait":false}},"fields":{"dragEnd":{},"moveEnd":{},"doMove":{},"doSave":{},"doEraseLoop":{},"moveLock":{},"px":{},"py":{},"ex":{},"ey":{},"eScale":{},"eTime":{},"esTime":{},"animTime":{},"scaleX":{},"isDragging":{},"color":{},"type":{},"t":{}}}
});
Tonyu.klass.define({
  fullName: 'user.PieceEffect',
  shortName: 'PieceEffect',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_PieceEffect_main() {
        "use strict";
        var _this=this;
        
        
        _this.alpha=1;
        
        _this.time=_this.time!=undefined?_this.time:0;
        if (_this.t!=undefined) {
          _this.stk=Tonyu.globals.$ease.easeOutExpo(_this.time*(1-_this.t)+(_this.maxt*_this.t),0,1,_this.maxt)/0.9990234375;
          
        } else {
          _this.stk=0;
          _this.t=0;
          
        }
        _this.sScale=_this.scaleX;
        _this.sAlpha=_this.alpha;
        _this.aScale=_this.eScale!=undefined?_this.eScale-_this.sScale:_this.aScale!=undefined?_this.aScale:0;
        _this.aAlpha=_this.eAlpha!=undefined?_this.eAlpha-_this.sAlpha:_this.aAlpha!=undefined?_this.aAlpha:0;
        _this.sx=_this.x;
        _this.sy=_this.y;
        _this.ax=_this.ex!=undefined?_this.ex-_this.sx:0;
        _this.ay=_this.ey!=undefined?_this.ey-_this.sy:0;
        _this.tk=0;
        while (1) {
          Tonyu.checkLoop();
          _this.time++;
          if (_this.time>_this.maxt) {
            _this.die();
          }
          _this.tk=(Tonyu.globals.$ease.easeOutExpo((_this.time*(1-_this.t)+(_this.maxt*_this.t)),0,1,_this.maxt)/0.9990234375-_this.stk)/(1-_this.stk);
          _this.x=_this.sx+_this.ax*_this.tk;
          _this.y=_this.sy+_this.ay*_this.tk;
          _this.scaleX=_this.sScale+_this.aScale*_this.tk;
          _this.alpha=_this.sAlpha+_this.aAlpha*_this.tk;
          _this.update();
          
        }
      },
      fiber$main :function _trc_PieceEffect_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _this.alpha=1;
        
        _this.time=_this.time!=undefined?_this.time:0;
        if (_this.t!=undefined) {
          _this.stk=Tonyu.globals.$ease.easeOutExpo(_this.time*(1-_this.t)+(_this.maxt*_this.t),0,1,_this.maxt)/0.9990234375;
          
        } else {
          _this.stk=0;
          _this.t=0;
          
        }
        _this.sScale=_this.scaleX;
        _this.sAlpha=_this.alpha;
        _this.aScale=_this.eScale!=undefined?_this.eScale-_this.sScale:_this.aScale!=undefined?_this.aScale:0;
        _this.aAlpha=_this.eAlpha!=undefined?_this.eAlpha-_this.sAlpha:_this.aAlpha!=undefined?_this.aAlpha:0;
        _this.sx=_this.x;
        _this.sy=_this.y;
        _this.ax=_this.ex!=undefined?_this.ex-_this.sx:0;
        _this.ay=_this.ey!=undefined?_this.ey-_this.sy:0;
        _this.tk=0;
        
        _thread.enter(function _trc_PieceEffect_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(1)) { __pc=3     ; break; }
              _this.time++;
              if (_this.time>_this.maxt) {
                _this.die();
              }
              _this.tk=(Tonyu.globals.$ease.easeOutExpo((_this.time*(1-_this.t)+(_this.maxt*_this.t)),0,1,_this.maxt)/0.9990234375-_this.stk)/(1-_this.stk);
              _this.x=_this.sx+_this.ax*_this.tk;
              _this.y=_this.sy+_this.ay*_this.tk;
              _this.scaleX=_this.sScale+_this.aScale*_this.tk;
              _this.alpha=_this.sAlpha+_this.aAlpha*_this.tk;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      draw :function _trc_PieceEffect_draw(ctx) {
        "use strict";
        var _this=this;
        var scale;
        var colorRatio;
        var size;
        var white;
        
        scale = _this.scaleX;
        
        colorRatio = 1.5;
        
        size = 15;
        
        ctx.fillStyle=Tonyu.globals.$ctx.rgba(Tonyu.bindFunc(_this,_this.color).r,Tonyu.bindFunc(_this,_this.color).g,Tonyu.bindFunc(_this,_this.color).b,Tonyu.bindFunc(_this,_this.color).a*_this.alpha);
        ctx.fillStyle=Tonyu.globals.$ctx.rgba(255,255,255,0.7*_this.alpha);
        white = Tonyu.globals.$ctx.color(255,255,255,0.7*_this.alpha);
        
        if (_this.type==1) {
          ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(255,42,32,0.7*_this.alpha),white,1-_this.alpha));
          Tonyu.globals.$ctx.circle(ctx,_this.x,_this.y,size*scale,true);
          
        } else {
          if (_this.type==2) {
            ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(98,112,185,0.7*_this.alpha),white,1-_this.alpha));
            Tonyu.globals.$ctx.fillRect(ctx,_this.x,_this.y,size,size,scale);
            
          } else {
            if (_this.type==3) {
              ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(15,232,20,0.7*_this.alpha),white,1-_this.alpha));
              Tonyu.globals.$ctx.triangle(ctx,_this.x,_this.y,size*scale,true);
              
            } else {
              if (_this.type==4) {
                ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(252,252,18,0.85*_this.alpha),white,1-_this.alpha));
                Tonyu.globals.$ctx.moon(ctx,_this.x,_this.y,size*scale,true);
                
              } else {
                if (_this.type==5) {
                  ctx.fillStyle=Tonyu.globals.$ctx.rgbaString(Tonyu.globals.$ctx.colorMix(Tonyu.globals.$ctx.color(180,5,180,0.7*_this.alpha),white,1-_this.alpha));
                  Tonyu.globals.$ctx.sparkle(ctx,_this.x,_this.y,size*scale,true);
                  
                }
              }
            }
          }
        }
      },
      init :function _trc_PieceEffect_init(color,sScale,sAlpha,maxt,escale,ealpha) {
        "use strict";
        var _this=this;
        
      },
      fiber$init :function _trc_PieceEffect_f_init(_thread,color,sScale,sAlpha,maxt,escale,ealpha) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true},"init":{"nowait":false}},"fields":{"color":{},"scaleX":{},"alpha":{},"type":{},"t":{},"stk":{},"tk":{},"time":{},"maxt":{},"sScale":{},"sAlpha":{},"eScale":{},"eAlpha":{},"aScale":{},"aAlpha":{},"sx":{},"sy":{},"ex":{},"ey":{},"ax":{},"ay":{}}}
});

//# sourceMappingURL=concat.js.map